// procedures to support WebSnarker
// CS 297 Group Project
// Team Bijoy/Freeman/Cutler

// prepare for Snarking
var gSnarkObj = null;
var gTabBrowser = null;
var gBrowsers = null;
var gUserChoice = {cancel : false};

function attachSnarkObj ()
{
    // if (!gSnarkObj) {
        gSnarkObj = Components.classes["@mozilla.org/WebSnarker;1"].
        createInstance(Components.interfaces.nsIWebSnarker);
    // }
}

function prepSnark ()
{
        attachSnarkObj ();
        testParamInterface (gSnarkObj);
        gTabBrowser = document.getElementById("content");
        gBrowsers =  gTabBrowser.browsers;
        var msg = "Browser Count = ";
        msg += gBrowsers.length + "\n";
        dump (msg);
        
        window.openDialog("chrome://websnarker/content/wsFileDialog.xul", 
            "czFileDialog", "chrome,modal,resizable=yes", 
            gSnarkObj, gUserChoice);

        // var outpath = askOutputPath ();
        var msg = "targetPath = " + gSnarkObj.outputPath + "\n";
        dump (msg);
        // var gTabBrowser = document.getElementById("content");
        // var browsers =  gTabBrowser.browsers;
}

function snarkDocument (document)
{
     var result = gSnarkObj.SnarkFiles(document);
     if (result == false) {
        dump ("Error: SnarkFiles failed, but no exception report\n");
     }
}

function reportUrl (url)
{
     var msg = "WebSnarker overlay will copy all requested files\n";
     msg += "from URL ";
     msg += url + "\n";
     dump (msg);
}

function snarkBrowser (browser)
{
     var url = browser.currentURI.spec;
     if ((!url) || (url == '') || (url == 'about:blank')) {
        // it's a Boojum
        return;
     }

     // If control gets here, we have a non-Null browser
     reportUrl (url)
     var webNav = browser.webNavigation;
     snarkDocument (webNav.document);
}

// Get preferred outputTarget from user, then snark files
// for current loaded browser
function snarkCurrentBrowser()
{
    // alert ("about to create new instance");
    try {
        prepSnark ();
        if (gUserChoice.cancel) {
            // user bailed out
            return;
        }
        snarkBrowser (gTabBrowser.selectedBrowser);
        var url = gTabBrowser.currentURI.spec;
        if  ((url) && (url != '')) {
            reportUrl (url);
            snarkDocument (webNav.document);
        }
    }
    catch (e) { 
        dump ("Exception return from websnark snarkCurrentBrowser: " + e + "\n");
    }

    // The below always caused exception.
    // var refcount = gSnarkObj.Release(0);
    // alert ("Refcount = " + refcount);
}

// Get preferred outputTarget from user, then snark files
// for all loaded browsers
function snarkAllTabs()
{
    // alert ("about to create new instance");
    try {
        prepSnark ();
        if (gUserChoice.cancel) {
            // user bailed out
            return;
        }

        // Snark 'em all!  All, I tell ye!
        for (i = 0; i < gBrowsers.length; i++) {
            msg = "Snarking for tab " + i + "\n";
            dump (msg);
            snarkBrowser (gBrowsers[i]);
        }
    }
    catch (e) { 
        dump ("Exception return from websnarker snarkAllTabs: " + e);
    }
}


function testParamInterface (gSnarkObj)
{
    var errMsg;
    try {
        gSnarkObj.saveCurrentDoc = true;
        errMsg = "Error: failed to set saveCurrentDoc flag ";
        if (true != gSnarkObj.saveCurrentDoc) {
            errMsg += "true\n";
            dump (errMsg);
        }
        gSnarkObj.saveCurrentDoc = false;
        errMsg = "Error: failed to set saveCurrentDoc flag ";
        if (false != gSnarkObj.saveCurrentDoc) {
            errMsg += "false\n";
            dump (errMsg);
        }
        dump ("Flag sets tested\n");

        // Set the rest without testing
        // (Check in debugger)
        gSnarkObj.outputPath = 'websnarkerOutDir';
        gSnarkObj.saveCurrentDoc = true;
        gSnarkObj.saveHtml = true;
        gSnarkObj.saveText = true;
        gSnarkObj.saveImages = true;
     }
     catch (e) { 
        dump ("Exception return from websnark do-it: " + e);
     }
}
    
    function sayOvHi()
    {
        msg="Entered Websnarker Overlay\n";
        dump (msg);
    }

        
    function askOutputPath (lSnarkObj)
    {
        attachSnarkObj ();
        targetPath = lSnarkObj.outputPath;
        const nsIFilePicker = Components.interfaces.nsIFilePicker;
        var fp = Components.classes["@mozilla.org/filepicker;1"]
                    .createInstance(nsIFilePicker);
        var mode = nsIFilePicker.modeOpen;
        mode |= nsIFilePicker.modeGetFolder;
        fp.init(window, targetPath, mode);
        if (fp.show() != nsIFilePicker.returnOK) {
            lSnarkObj.outputPath = '';
        }
       lSnarkObj.outputPath = fp.fileURL.spec;
    }

    function changeWsPreferences () {
        attachSnarkObj();
        window.openDialog("chrome://websnarker/content/wsPrefsDialog.xul", 
            "czPrefsDialog", "chrome,modal,resizable=yes", 
            gSnarkObj);
        dump ("gSnarkObj.saveImages = " + gSnarkObj.saveImages + "\n");
        dump ("gSnarkObj.saveText = " + gSnarkObj.saveText + "\n");
        dump ("gSnarkObj.saveHtml = " + gSnarkObj.saveHtml + "\n");
        dump ("gSnarkObj.saveCurrentDoc = " + gSnarkObj.saveCurrentDoc + "\n");
    }

    /*
    filepicker is in include/widget
910     var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
911     fp.init(window, gNavigatorBundle.getString("openFile"), nsIFilePicker.modeOpen);
912     fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterText | nsIFilePicker.filterImages |
913                      nsIFilePicker.filterXML | nsIFilePicker.filterHTML);
914 
915     if (fp.show() == nsIFilePicker.returnOK)
916       openTopWin(fp.fileURL.spec);
917  */
    
