// XPI installer for websnarker
// Student: Jesse Freeman
// Class: CS297, Project 2
// Instructor: Mike Pinkerton

function reportError (toDoWhat) {
    var errorReported = false;
    var errCode;
    var msg;
    errCode = getLastError( );        
    if (0 != errCode) {
        msg = "Received error on attempt to ";
        msg += toDoWhat;
        msg += "\nError Code = " + errCode;
        alert (msg);
        resetError();
        errorReported = true;
    }
    return errorReported;
}

function reportSuccess (toDoWhat)
{
    msg = "Successful in attempt to " + toDoWhat;
    alert (msg);
}

function reportResult (toDoWhat)
{
    if (!reportError(toDoWhat)) {
        reportSuccess (toDoWhat)
    }
}

// 1.  Remove previous version of package, if any
    var myFile = "websnarker.jar";
    uninstall ("websnarker");
    reportError("uninstall websnarker");

// 2.  initialize installation package 
    initInstall(                      // initialize the installation
       "Install websnarker",                 // display name of installation
        "websnarker",                         // package name
        "0.0.1",                        // version of install
        1);                             // flags - an optional argument, 
    var toDoWhat = "initialize installation package.";
    reportError(toDoWhat);

// 3.  Specify target directory
                                  // reserved for future use
    f = getFolder("chrome");          // specify a target directory
    setPackageFolder(f);
    // add software to the installation
    addFile("adding websnarker", myFile, getFolder ("chrome"), "");
    toDoWhat = "specify target directory.";
    reportError(toDoWhat);

// 4. Add content directory
    registerChrome(
        CONTENT | DELAYED_CHROME,       // chrome switch (i.e., type)
        getFolder("chrome","websnarker.jar"), // destination of package
        "content/");               // location of manifest in package
    toDoWhat = "add content directory.";
    reportResult(toDoWhat);

// 5. Add skin directory
    registerChrome(
        SKIN | DELAYED_CHROME,       // chrome switch (i.e., type)
        getFolder("chrome","websnarker.jar"), // destination of package
        "skin/");               // location of manifest in package
    toDoWhat = "add skin directory.";
    reportError(toDoWhat);

// 6. Add locale directory
    registerChrome(
        LOCALE | DELAYED_CHROME,       // chrome switch (i.e., type)
        getFolder("chrome","websnarker.jar"), // destination of package
        "locale/en-US/");               // location of manifest in package
    toDoWhat = "add locale directory.";
    reportError(toDoWhat);

//  9. Install the XPCOM component
    // var componentsDir = getFolder("Components"); 
    var componentsDir = getFolder("components"); 
    // add the DLL and say where it'll go 
    // Question:  Why use InstallVersion one place and a string
    // in the other?  addFile supports both.  Following Weblock example.
    addDirectory ("webSnarker", 1.0, 
         "components", componentsDir, ""); 
    toDoWhat = "add webSnarker components directory";
    reportResult(toDoWhat);
 
    // add the typelib also 
    /*
    addFile (
        "webSnarker.xpt", "1.0", "webSnarker.xpt", componentsDir, "");  
    toDoWhat = "add webSnarker.rpt";
    reportResult(toDoWhat);
    */

// 8. Perform the installation 
    if (0 == getLastError( ))         // if there have been no errors:
        performInstall( );              // install "websnarker.jar"
    else {                             // otherwise
        cancelInstall( );               // cancel the installation.
    }

    toDoWhat = "Complete WebSnarker Installation";
    reportResult(toDoWhat);
